#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;

ll t, n, k;
vector<vector<ll>> g;

vector<ll> ans;
vector<bool> used;
deque<ll> q;

void bfs() {
    ll v;
    while (!q.empty()) {
        v = q.front();
        q.pop_front();
        for (ll u : g[v]) {
            if (used[u]) {
                continue;
            }
            used[u] = true;
            ans[u] = min(ans[u], ans[v] + 1);
            q.push_back(u);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> k >> t;
    g.resize(n);
    ll v, u;
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v;
        --u; --v;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    if (t == 0) {
        ans.assign(n, INF);
        used.assign(n, false);
        ans[0] = 0;
        used[u] = true;
        q.push_back(0);
        bfs();
        sort(ans.begin(), ans.end());
        cout << ans[n - k - 1];
    } else {
        for (int i = 0; i < n; ++i) {
            ans.assign(n, INF);
            used.assign(n, false);
            ans[i] = 0;
            used[i] = true;
            q.clear();
            q.push_back(i);
            bfs();
            sort(ans.begin(), ans.end());
            cout << ans[n - k - 1] << " ";
        }
    }
}
