#include <bits/stdc++.h>

using namespace std;

vector<int> primes(1e6 + 1, 1);

bool check(int x, int y) {
    if (x < y) {
        swap(x, y);
    }
    return !(x % y == 0 && primes[x / y]);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    primes[1] = primes[0] = 0;
    for (int i = 1; i <= 1e6; ++i) {
        if (primes[i]) {
            for (int j = 2 * i; j <= 1e6; j += i) {
                primes[j] = 0;
            }
        }
    }
    int n;
    cin >> n;
    vector<int> ar(n);
    for (int i = 0; i < n; ++i) {
        cin >> ar[i];
    }
    vector<int> colors(n, 1);
    int cur = 0;
    while (cur < n - 1) {
        bool fl = true;
        for (int i = cur + 1; i < n; ++i) {
            if (!check(ar[cur], ar[i])) {
                colors[i] = 2;
            } else if (fl) {
                fl = false;
                cur = i;
            }
        }
    }
    for (int i : colors) {
        cout << i << " ";
    }
}
