#include <bits/stdc++.h>

using namespace std;

vector<int> primes(1e6 + 1, 1);

bool check(int x, int y) {
    if (x < y) {
        swap(x, y);
    }
    return !(x % y == 0 && primes[x / y]);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    primes[1] = primes[0] = 0;
    for (int i = 1; i <= 1e6; ++i) {
        if (primes[i]) {
            for (int j = 2 * i; j <= 1e6; j += i) {
                primes[j] = 0;
            }
        }
    }
    int n;
    cin >> n;
    vector<int> ar(n);
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> ar[i];
        mx = max(mx, ar[i]);
    }

    if (n <= 10) {
        vector<int> colors(n, 1);
        colors[0] = 1;
        for (int i = 1; i < n; ++i) {
            for (int j = 0; j < i; ++j) {
                if (!check(ar[i], ar[j])) {
                    if (colors[j] == 1) {
                        colors[i] = 2;
                    } else {
                        colors[i] = 1;
                    }
                    break;
                }
            }
        }
        for (int i : colors) {
            cout << i << " ";
        }
        exit(0);
    }

    vector<int> colors(n, 1);

    if (mx > 4) {
        vector<pair<int, int>> ar1(n);
        for (int i = 0; i < n; ++i) {
            ar1[i] = {ar[i], i};
        }
        sort(ar1.begin(), ar1.end());

        colors[ar1[0].second] = 1;
        for (int i = 1; i < n; ++i) {
            int clr = colors[ar1[i - 1].second];
            if (check(ar1[i - 1].first, ar1[i].first)) {
                colors[ar1[i].second] = clr;
            } else {
                colors[ar1[i].second] = (clr == 1) + 1;
            }
        }
        for (int i : colors) {
            cout << i << " ";
        }
        exit(0);
    }

    colors[0] = 1;
    int s = -1;
    for (int i = 1; i < n; ++i) {
        if (!check(ar[0], ar[i])) {
            colors[i] = 2;
            if (s == -1) {s = i;}
        }
    }
    if (s != -1) {
        for (int i = 0; i < n; ++i) {
            if (check(ar[s], ar[i])) {
                colors[i] = 2;
            }
        }
    }

    for (int i : colors) {
        cout << i << " ";
    }
}